# 使用するイメージの指定
image: docker:stable

# 使用するサービスの指定
services:
   - docker:dind

# 環境変数
variables:
   CONTAINER_IMAGE: registry.gitlab.com/$CI_PROJECT_PATH
   REPO_NAME: gitlab.com/cloudnativetips/ci-sample
   TRIVY_VERSION: 0.37.3

before_script:
   - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com

# ステージ
stages:
   - stage-build
   - stage-scan
   - stage-update-latest-image

# stage-buildステージ
build:
   # ステージ
   stage: stage-build
   # 処理内容
   script:
      - docker build --target unittest -t $CONTAINER_IMAGE:work .
      - docker run $CONTAINER_IMAGE:work cat ./report.xml > report.xml
      - docker run $CONTAINER_IMAGE:work cat ./cover.txt
      - docker build --target build_image -t $CONTAINER_IMAGE:$CI_COMMIT_SHA .
      - docker push $CONTAINER_IMAGE:$CI_COMMIT_SHA
   # カバレッジ
   coverage: '/coverage: \d+\.\d+% of statements/'
   # アーティファクト
   artifacts:
      reports:
         junit: report.xml
      # CI実行契機
   only:
      - merge_requests
      - main

# stage-scanステージ
scan:
   stage: stage-scan
   script:
      - docker pull $CONTAINER_IMAGE:$CI_COMMIT_SHA
      - wget --no-verbose https://github.com/aquasecurity/trivy/releases/download/v${TRIVY_VERSION}/trivy_${TRIVY_VERSION}_Linux-64bit.tar.gz -O - | tar -zxvf -
      - ./trivy --cache-dir .trivycache/ image --exit-code 0 --no-progress --format template --template "@contrib/gitlab.tpl" -o gl-container-scanning-report.json $CONTAINER_IMAGE:$CI_COMMIT_SHA
      - cat gl-container-scanning-report.json
      - ./trivy --cache-dir .trivycache/ image --exit-code 1 --severity CRITICAL --no-progress $CONTAINER_IMAGE:$CI_COMMIT_SHA
   artifacts:
      reports:
         container_scanning: gl-container-scanning-report.json
   only:
      - merge_requests
      - main

lint:
   image: registry.gitlab.com/gitlab-org/gitlab-build-images:golangci-lint-alpine
   stage: stage-scan
   before_script: []
   script:
      - "[ -e .golangci.yml ] || cp /golangci/.golangci.yml ."
      - golangci-lint run --out-format code-climate | tee gl-code-quality-report.json | jq -r '.[] | "\(.location.path):\(.location.lines.begin) \(.description)"'
   artifacts:
      reports:
         codequality: gl-code-quality-report.json
      paths:
         - gl-code-quality-report.json
   allow_failure: true
   only:
      - merge_requests
      - main

# stage-update-latest-imageステージ
update-latest-image:
   stage: stage-update-latest-image
   script:
      - docker pull $CONTAINER_IMAGE:$CI_COMMIT_SHA
      - docker tag $CONTAINER_IMAGE:$CI_COMMIT_SHA $CONTAINER_IMAGE:latest
      - docker push $CONTAINER_IMAGE:latest
   only:
      - main
